/*
 * A few changes are made by hunsoo@sensor.kaist.ac.kr 1997/8/6
 * If any bugs reside in this file, the culprit is me
 */
/*
 * Copyright 1988 by Siemens All Rights Reserved
 * 
 * Permission to use, copy, modify and distribute this software is hereby
 * granted, provided that this copyright notice appear in all copies and that
 * the copyright notice appear in supporting documentation.
 * 
 * please feel free to add any bells and neats to this program -
 * 
 * written 16-17 Mar 1988 by claus gittinger
 * 
 * Email: ...!decvax!unido!athen!claus
 * 
 * a little font editor by claus usage: xfed [-fg color] [-bg color] [-bd color]
 * [-bw number]  f_fontname.bdf
 */

#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/signal.h>
#include <errno.h>

#include "defs.h"
#include "common.h"

#include "bitmaps/bit.prev"
#include "bitmaps/bit.pprev"
#include "bitmaps/bit.ppprev"
#include "bitmaps/bit.next"
#include "bitmaps/bit.nnext"
#include "bitmaps/bit.nnnext"

#include "bitmaps/bit.mprev"
#include "bitmaps/bit.mnext"
#include "bitmaps/bit.redraw"
#include "bitmaps/bit.msync"

#include "bitmaps/bit.left"
#include "bitmaps/bit.up"
#include "bitmaps/bit.down"
#include "bitmaps/bit.right"
#include "bitmaps/bit.nobbx"
#include "bitmaps/bit.nogrid"

#include "bitmaps/bit.icon"
#include "bitmaps/bit.undo"
#include "bitmaps/bit.doit"
#include "bitmaps/bit.save"
#include "bitmaps/bit.exit"

#include "bitmaps/bit.incre"
#include "bitmaps/bit.decre"

Window  XCreateWindow(Display *, Window, int, int, unsigned int,
	unsigned int, unsigned int, int, unsigned int, Visual *,
	long unsigned int, XSetWindowAttributes *);

Window  main_Win, charinfo_Win, info_Win, edit_Win, matrix_Win;
Window	message_Win, buffers_Win;
Window  next_Win, nnext_Win, nnnext_Win;
Window	prev_Win, pprev_Win, ppprev_Win;
Window	mprev_Win, mnext_Win, redraw_Win, msync_Win;
Window	left_Win, up_Win, down_Win, right_Win;
Window	nobbx_Win, nogrid_Win;
Window	exit_Win, save_Win, undo_Win, doit_Win, image_Win;
Window	incre_Win, decre_Win;

Display *dpy;
Colormap cmap;
GC      gc;
int     screen;
int     winW, winH;
char   *borderColor = "black";
char   *foregroundColor = "black";
char   *backgroundColor = "white";
int     borderWidth = 1;
long    foreground_pixel, backgroundPixel, borderPixel;
char   *fontfilename = NULL;

Pixmap  save_Button, exit_Button, undo_Button, doit_Button;
Pixmap 	next_Button, nnext_Button, nnnext_Button;
Pixmap	prev_Button, pprev_Button, ppprev_Button;
Pixmap	mprev_Button, mnext_Button, redraw_Button, msync_Button;
Pixmap	left_Button, up_Button, down_Button, right_Button;
Pixmap	buffers_Button;
Pixmap	nobbx_Button, nogrid_Button;
Pixmap	incre_Button, decre_Button;

static struct character *cp;

int     charIndex = 0;
int     firstSave = 1;
int	currmap = 0;
int	totalmap;

int     minx, miny, maxx, maxy;

#define SPACE		5
#define info_height	20
#define charinfo_height	20

int     pixel_size = 16;
int	square_sideunit;
int     grid = 1;

int     info_x, info_y;
int     info_width;
int     charinfo_x, charinfo_y;
int     charinfo_width;
int     edit_x, edit_y;
int	matrix_x, matrix_y;
int	matrix_width, matrix_height;

int     edit_width, edit_height;
int     image_x, image_y;
int     image_x0, image_nc;
int     image_width, image_height;

int	buffers_x, buffers_y;
int	buffers_width, buffers_height;
int	message_x, message_y;
int	message_width, message_height;

int     next_x, next_y;
int     nnext_x, nnext_y;
int     nnnext_x, nnnext_y;
int     prev_x, prev_y;
int     pprev_x, pprev_y;
int     ppprev_x, ppprev_y;

int	mprev_x, mprev_y;
int	mnext_x, mnext_y;
int	redraw_x, redraw_y;
int	msync_x, msync_y;

int     left_x, left_y;
int     up_x, up_y;
int     down_x, down_y;
int     right_x, right_y;
int     nobbx_x, nobbx_y;
int     nogrid_x, nogrid_y;
int	incre_x, incre_y;
int	decre_x, decre_y;

int     undo_x, undo_y;
int     doit_x, doit_y;
int     exit_x, exit_y;
int     save_x, save_y;


unsigned long red_pixel, blue_pixel, green_pixel;

#define SETBIT		0
#define CLEARBIT	1
#define COMBIT		2

#define SHIFT_LEFT	0
#define SHIFT_UP	1
#define SHIFT_DOWN	2
#define SHIFT_RIGHT	3

void	setupWindow(int argc, char **argv);
void	do_events(void);
int	which_square(int x, int y, int *prow, int *pcol);
void	bit_operation(int what, int row, int col);
void	set_square(int row, int col);
void	clear_square(int row, int col);
void	draw_boundingbox(void);
void	alternate_char(int x);

void	undo_character(void);
void	doit_character(void);
void	or_operation(struct character *dst, struct character *src);
void	backup_character(struct character *dst, struct character *src);
void	copy_character(struct character *dst, struct character *src);
void	prevnext_character(int incre);

void	put_msg(char *p);

void	drawbox_inMatrix(void);
void	redraw_matrixWindow(void);
void	redraw_buffersWindow(void);
void	redraw_editWindow(void);
void	redraw_charinfoWindow(void);
void	redraw_infoWindow(void);
void	redraw_buttonInWindow(Pixmap pixmap, Window win, int w, int h);
void	redraw_quitWindow(void);
void	redraw_saveWindow(void);
void	redraw_undoWindow(void);
void	redraw_doitWindow(void);

void	redraw_nextWindow(void);
void	redraw_nnextWindow(void);
void	redraw_nnnextWindow(void);
void	redraw_prevWindow(void);
void	redraw_pprevWindow(void);
void	redraw_ppprevWindow(void);

void	redraw_mprevWindow(void);
void	redraw_mnextWindow(void);
void	redraw_redrawWindow(void);
void	redraw_msyncWindow(void);

void	shift_character(const int shtype);
void	select_char(int x, int y, int whichb);
void	buffers_handle(int x, int y, int whichb);
void	redraw_leftWindow(void);
void	redraw_upWindow(void);
void	redraw_downWindow(void);
void	redraw_rightWindow(void);
void	redraw_nobbxWindow(void);
void	redraw_nogridWindow(void);
void	redraw_increWindow(void);
void	redraw_decreWindow(void);

void	redraw_imageWindow(void);

void	toggle_nobbox(void);
void	toggle_nogrid(void);
void	incre_decre(int decrease);
void	change_map(int incre);
void	find_map(void);
unsigned long NameToPixel(char *name);
void	set_gclinewidth(GC gc, const int linewidth);

void	output(struct fontset * font, char *filename);
void	make_buffers(void);
int	find_buffindex(void);

struct fontset *fset;
struct bbox *bbp;	/* temp bbox structure */
struct bbox *fbbp;	/* temp bbox structure */

int	orig_col, orig_row;
int	message_exists = 0;
struct character **buffers;
int	curr_bindex;
int	dont_drawbbox = 0;
int	dont_drawgrid = 0;
int	buffers_flags[16];
int	max_height, max_width;
char	*undo_or_doit="current char is changed!\n"
	" Please undo(dont accept) or doit(accept)";

int
main(int argc, char **argv)
{
	char	*def_fontfname = "courB18.bdf";
	char	*noinputcase= "Since you have not given the input font file"
		"name, I dare to assume\nthat the input font file was ";
	char	*usage="usage: programname [-fg color] [-bg color] [-bw n] "
		"[-bd color]\nsome.bdf.file\n\n";
	char  **ap, *p;

	for (ap = (argv + 1); *ap != NULL; ap++) {
		p = *ap;
		if (strcmp(p, "-bd") == 0)
			borderColor = *++ap;
		else if (strcmp(p, "-fg") == 0)
			foregroundColor = *++ap;
		else if (strcmp(p, "-bg") == 0)
			backgroundColor = *++ap;
		else if (strcmp(p, "-bw") == 0)
			sscanf(*++ap, "%d", &borderWidth);
		else
			fontfilename = *ap;
	}

	square_sideunit = (pixel_size + grid);

	if (fontfilename == NULL) {
		printf("\n%s\n", usage);
		fontfilename = def_fontfname;
		printf("%s%s.\n", noinputcase, def_fontfname);
		fset = initial(fontfilename);
	} else
		fset = initial(fontfilename);

	totalmap = fset->f_nchars / 256;
	if (fset->f_nchars % 256)
		totalmap++;
		
	fbbp = bbp = &fset->f_boundingbox;
	max_height = fbbp->bb_height;
	max_width = fbbp->bb_width;
	minx = bbp->bb_offx;
	maxx = bbp->bb_width + bbp->bb_offx;
	miny = bbp->bb_offy;
	maxy = bbp->bb_height + bbp->bb_offy;

	orig_col = -fbbp->bb_offx;
	orig_row = max_height + fbbp->bb_offy;
	make_buffers();

	setupWindow(argc, argv);

	cp = fset->f_characters[0];
	charIndex = 0;
	do_events();
	return 0;
}


void
setupWindow(int argc, char **argv)
{
	int	tmp0, tmp1;
	XGCValues xgcv;
	unsigned long xgcv_mask;
	XSetWindowAttributes xswa;
	char   *display;
	Visual  visual;
	XSizeHints szhint;
	XColor  def, exact;
	extern char *getenv(const char *);
	display = "";

	if (!(dpy = XOpenDisplay(display)))
		err("%s(): Cannot open display\n", __F);

	screen = DefaultScreen(dpy);
	cmap = DefaultColormap(dpy, screen);

	XAllocNamedColor(dpy, cmap, borderColor, &def, &exact);
	borderPixel = def.pixel;
	XAllocNamedColor(dpy, cmap, foregroundColor, &def, &exact);
	foreground_pixel = def.pixel;
	XAllocNamedColor(dpy, cmap, backgroundColor, &def, &exact);
	backgroundPixel = def.pixel;
	XAllocNamedColor(dpy, cmap, "red", &def, &exact);
	red_pixel = def.pixel;
	XAllocNamedColor(dpy, cmap, "green", &def, &exact);
	green_pixel = def.pixel;
	XAllocNamedColor(dpy, cmap, "blue", &def, &exact);
	blue_pixel = def.pixel;

	info_x = info_y = 0;
	charinfo_x = 0;
	charinfo_y = info_y + SPACE + info_height;

	edit_x = 0;
	matrix_y = edit_y = charinfo_y + SPACE + charinfo_height;

	edit_width = square_sideunit * fset->f_boundingbox.bb_width;
	edit_height = square_sideunit * fset->f_boundingbox.bb_height;

	buffers_x = matrix_x = edit_width + SPACE;
	buffers_width = matrix_width  = 16 * (max_width+1);
	matrix_height = 16 * (max_height+1);

	image_x = 0;
	image_y = info_height + SPACE + charinfo_height
		+ SPACE + edit_height + SPACE;
	buffers_y = info_height + SPACE + charinfo_height
		+ SPACE + matrix_height + SPACE;

	image_width = edit_width; /*  + 4 * (SPACE + prev_width) + SPACE; */
	buffers_height= image_height =
		SPACE + fset->f_boundingbox.bb_height + SPACE;

	image_x0 = (image_width - fset->f_boundingbox.bb_width) / 2;
	image_nc = image_x0 / fset->f_boundingbox.bb_width;

	ppprev_x = SPACE;
	pprev_x  = ppprev_x + ppprev_width + SPACE;
	prev_x   = pprev_x + pprev_width + SPACE;
	next_x   = prev_x + prev_width + SPACE;
	nnext_x  = next_x + next_width + SPACE;
	nnnext_x = nnext_x + nnext_width + SPACE;

	mprev_x  = nnnext_x + nnnext_width + SPACE + 16;
	mnext_x  = mprev_x + mprev_width + SPACE;
	redraw_x = mnext_x + mnext_width + SPACE;
	msync_x  = redraw_x + redraw_width + SPACE;

	/*
	 * Total window width
	 */
	winW = edit_width + matrix_width + 2 * SPACE;
	if (winW < redraw_x + redraw_width + SPACE)
		winW = redraw_x + redraw_width + SPACE;
	info_width     = winW;
	charinfo_width = winW;

	tmp0 = image_y + SPACE + image_height;
	tmp1 = buffers_y + SPACE + buffers_height;

	if (tmp0 > tmp1) {
		ppprev_y = pprev_y  = prev_y   = next_y   = nnext_y  =
		nnnext_y = mprev_y  = mnext_y  = redraw_y = msync_y = tmp0;
	} else {
		ppprev_y = pprev_y  = prev_y   = next_y   = nnext_y  =
		nnnext_y = mprev_y  = mnext_y  = redraw_y = msync_y = tmp1;
	}

	left_x  = ppprev_x;
	up_x    = pprev_x;
	down_x  = prev_x;
	right_x = next_x;
	nobbx_x = nnext_x;
	nogrid_x = nnnext_x;
	incre_x = nogrid_x + SPACE + nogrid_width;
	decre_x = incre_x + SPACE + incre_width;

	left_y = up_y = down_y = right_y = nobbx_y = nogrid_y
		= incre_y = decre_y = ppprev_y + (SPACE + ppprev_height);

	exit_x = ppprev_x;
	save_x =  exit_x + SPACE + exit_width;
	undo_x =  save_x + SPACE + save_width;
	doit_x =  undo_x + SPACE + undo_width;
	message_x = doit_x + SPACE + doit_width;

	message_y = save_y = exit_y = undo_y =  doit_y =
		left_y + SPACE + left_height;

	message_width = winW - message_x - SPACE;
	message_height = exit_height;

	winH =  exit_y + SPACE + exit_height + SPACE;

	szhint.flags = PPosition | PSize;
	szhint.x = 0;
	szhint.y = 0;
	szhint.width = winW;
	szhint.height = winH;

	xswa.backing_store = NotUseful;
	xswa.event_mask = ExposureMask;
	xswa.background_pixel = backgroundPixel;
	xswa.border_pixel = borderPixel;
	visual.visualid = CopyFromParent;
	main_Win = XCreateWindow(dpy, RootWindow(dpy, DefaultScreen(dpy)),
		0, 0, szhint.width, szhint.height, borderWidth,
		DefaultDepth(dpy, 0), InputOutput, &visual,
		CWEventMask | CWBackingStore | CWBorderPixel | CWBackPixel,
		&xswa);

	XSetStandardProperties(dpy, main_Win, "fed", "fed",
		XCreateBitmapFromData(dpy, main_Win, icon_bits,
			icon_width, icon_height), argv, argc, &szhint);

	XSelectInput(dpy, main_Win, ButtonPressMask | ExposureMask);
	XMapWindow(dpy, main_Win);

#if !defined(hunsoo)
	xgcv.line_width = 1;
	xgcv_mask = 0;
	xgcv_mask |= GCLineWidth;
	gc = XCreateGC(dpy, main_Win, xgcv_mask, &xgcv);
#else
	gc = XCreateGC(dpy, main_Win, 0L, &xgcv);
#endif

	XSetForeground(dpy, gc, foreground_pixel);
	XSetBackground(dpy, gc, backgroundPixel);

	info_Win = XCreateSimpleWindow(dpy, main_Win,
		info_x, info_y, info_width, info_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, info_Win, ExposureMask);

	charinfo_Win = XCreateSimpleWindow(dpy, main_Win,
		charinfo_x, charinfo_y, charinfo_width, charinfo_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, charinfo_Win, ExposureMask);

	matrix_Win = XCreateSimpleWindow(dpy, main_Win,
		matrix_x, matrix_y, matrix_width, matrix_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, matrix_Win, ExposureMask | ButtonPressMask |
		     Button1MotionMask | Button2MotionMask |
		     Button3MotionMask);

	buffers_Win = XCreateSimpleWindow(dpy, main_Win,
		buffers_x, buffers_y, buffers_width, buffers_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, buffers_Win, ExposureMask | ButtonPressMask |
		     Button1MotionMask | Button2MotionMask |
		     Button3MotionMask);

	edit_Win = XCreateSimpleWindow(dpy, main_Win,
		edit_x, edit_y, edit_width, edit_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, edit_Win, ExposureMask | ButtonPressMask |
		     Button1MotionMask | Button2MotionMask |
		     Button3MotionMask);
	xswa.cursor = XCreateFontCursor(dpy, XC_cross);
	/* XChangeWindowAttributes(dpy, edit_Win, CWCursor, &xswa); */

	ppprev_Win = XCreateSimpleWindow(dpy, main_Win,
		ppprev_x, ppprev_y, ppprev_width, ppprev_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, ppprev_Win, ExposureMask | ButtonPressMask);
	ppprev_Button = XCreateBitmapFromData(dpy, main_Win,
		ppprev_bits, ppprev_width, ppprev_height);

	pprev_Win = XCreateSimpleWindow(dpy, main_Win,
		pprev_x, pprev_y, pprev_width, pprev_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, pprev_Win, ExposureMask | ButtonPressMask);
	pprev_Button = XCreateBitmapFromData(dpy, main_Win,
		pprev_bits, pprev_width, pprev_height);

	prev_Win = XCreateSimpleWindow(dpy, main_Win,
		prev_x, prev_y, prev_width, prev_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, prev_Win, ExposureMask | ButtonPressMask);
	prev_Button = XCreateBitmapFromData(dpy, main_Win,
		prev_bits, prev_width, prev_height);

	next_Win = XCreateSimpleWindow(dpy, main_Win,
		next_x, next_y, next_width, next_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, next_Win, ExposureMask | ButtonPressMask);
	next_Button = XCreateBitmapFromData(dpy, main_Win,
		next_bits, next_width, next_height);

	nnext_Win = XCreateSimpleWindow(dpy, main_Win,
		nnext_x, nnext_y, nnext_width, nnext_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, nnext_Win, ExposureMask | ButtonPressMask);
	nnext_Button = XCreateBitmapFromData(dpy, main_Win,
		nnext_bits, nnext_width, nnext_height);

	nnnext_Win = XCreateSimpleWindow(dpy, main_Win,
		nnnext_x, nnnext_y, nnnext_width, nnnext_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, nnnext_Win, ExposureMask | ButtonPressMask);
	nnnext_Button = XCreateBitmapFromData(dpy, main_Win,
		nnnext_bits, nnnext_width, nnnext_height);

	/* previous map and next map */
	mprev_Win = XCreateSimpleWindow(dpy, main_Win,
		mprev_x, mprev_y, mprev_width, mprev_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, mprev_Win, ExposureMask | ButtonPressMask);
	mprev_Button = XCreateBitmapFromData(dpy, main_Win,
		mprev_bits, mprev_width, mprev_height);

	mnext_Win = XCreateSimpleWindow(dpy, main_Win,
		mnext_x, mnext_y, mnext_width, mnext_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, mnext_Win, ExposureMask | ButtonPressMask);
	mnext_Button = XCreateBitmapFromData(dpy, main_Win,
		mnext_bits, mnext_width, mnext_height);
	/* redraw map */

	redraw_Win = XCreateSimpleWindow(dpy, main_Win,
		redraw_x, redraw_y, redraw_width, redraw_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, redraw_Win, ExposureMask | ButtonPressMask);
	redraw_Button = XCreateBitmapFromData(dpy, main_Win,
		redraw_bits, redraw_width, redraw_height);

	msync_Win = XCreateSimpleWindow(dpy, main_Win,
		msync_x, msync_y, msync_width, msync_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, msync_Win, ExposureMask | ButtonPressMask);
	msync_Button = XCreateBitmapFromData(dpy, main_Win,
		msync_bits, msync_width, msync_height);


	left_Win = XCreateSimpleWindow(dpy, main_Win,
		left_x, left_y, left_width, left_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, left_Win, ExposureMask | ButtonPressMask);
	left_Button = XCreateBitmapFromData(dpy, main_Win,
		left_bits, left_width, left_height);

	up_Win = XCreateSimpleWindow(dpy, main_Win,
		up_x, up_y, up_width, up_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, up_Win, ExposureMask | ButtonPressMask);
	up_Button = XCreateBitmapFromData(dpy, main_Win,
		up_bits, up_width, up_height);

	down_Win = XCreateSimpleWindow(dpy, main_Win,
		down_x, down_y, down_width, down_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, down_Win, ExposureMask | ButtonPressMask);
	down_Button = XCreateBitmapFromData(dpy, main_Win,
		down_bits, down_width, down_height);

	right_Win = XCreateSimpleWindow(dpy, main_Win,
		right_x, right_y, right_width, right_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, right_Win, ExposureMask | ButtonPressMask);
	right_Button = XCreateBitmapFromData(dpy, main_Win,
		right_bits, right_width, right_height);

	nobbx_Win = XCreateSimpleWindow(dpy, main_Win,
		nobbx_x, nobbx_y, nobbx_width, nobbx_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, nobbx_Win, ExposureMask | ButtonPressMask);
	nobbx_Button = XCreateBitmapFromData(dpy, main_Win,
		nobbx_bits, nobbx_width, nobbx_height);

	nogrid_Win = XCreateSimpleWindow(dpy, main_Win,
		nogrid_x, nogrid_y, nogrid_width, nogrid_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, nogrid_Win, ExposureMask | ButtonPressMask);
	nogrid_Button = XCreateBitmapFromData(dpy, main_Win,
		nogrid_bits, nogrid_width, nogrid_height);

	incre_Win = XCreateSimpleWindow(dpy, main_Win,
		incre_x, incre_y, incre_width, incre_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, incre_Win, ExposureMask | ButtonPressMask);
	incre_Button = XCreateBitmapFromData(dpy, main_Win,
		incre_bits, incre_width, incre_height);


	decre_Win = XCreateSimpleWindow(dpy, main_Win,
		decre_x, decre_y, decre_width, decre_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, decre_Win, ExposureMask | ButtonPressMask);
	decre_Button = XCreateBitmapFromData(dpy, main_Win,
		decre_bits, decre_width, decre_height);


	save_Win = XCreateSimpleWindow(dpy, main_Win,
		save_x, save_y, save_width, save_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, save_Win, ExposureMask | ButtonPressMask);
	save_Button = XCreateBitmapFromData(dpy, main_Win,
		save_bits, save_width, save_height);

	exit_Win = XCreateSimpleWindow(dpy, main_Win,
		exit_x, exit_y, exit_width, exit_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, exit_Win, ExposureMask | ButtonPressMask);
	exit_Button = XCreateBitmapFromData(dpy, main_Win,
		exit_bits, exit_width, exit_height);

	doit_Win = XCreateSimpleWindow(dpy, main_Win,
		doit_x, doit_y, doit_width, doit_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, doit_Win, ExposureMask | ButtonPressMask);
	doit_Button = XCreateBitmapFromData(dpy, main_Win,
		doit_bits, doit_width, doit_height);

	undo_Win = XCreateSimpleWindow(dpy, main_Win,
		undo_x, undo_y, undo_width, undo_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, undo_Win, ExposureMask | ButtonPressMask);
	undo_Button = XCreateBitmapFromData(dpy, main_Win,
		undo_bits, undo_width, undo_height);

	image_Win = XCreateSimpleWindow(dpy, main_Win,
		image_x, image_y, image_width, image_height,
		1, borderPixel, backgroundPixel);

	XSelectInput(dpy, image_Win, ExposureMask | ButtonPressMask);
	xswa.cursor = XCreateFontCursor(dpy, XC_arrow);
	/* XChangeWindowAttributes(dpy, image_Win, CWCursor, &xswa); */

	message_Win = XCreateSimpleWindow(dpy, main_Win,
		message_x, message_y, message_width, message_height,
		1, borderPixel, backgroundPixel);
	XSelectInput(dpy, message_Win, ExposureMask);

	XMapWindow(dpy, info_Win);
	XMapWindow(dpy, charinfo_Win);
	XMapWindow(dpy, edit_Win);
	XMapWindow(dpy, matrix_Win);
	XMapWindow(dpy, buffers_Win);
	XMapWindow(dpy, message_Win);
	XMapWindow(dpy, image_Win);

	XMapWindow(dpy, pprev_Win);
	XMapWindow(dpy, ppprev_Win);
	XMapWindow(dpy, prev_Win);
	XMapWindow(dpy, next_Win);
	XMapWindow(dpy, nnext_Win);
	XMapWindow(dpy, nnnext_Win);

	XMapWindow(dpy, mprev_Win);
	XMapWindow(dpy, mnext_Win);
	XMapWindow(dpy, redraw_Win);
	XMapWindow(dpy, msync_Win);

	XMapWindow(dpy, left_Win);
	XMapWindow(dpy, up_Win);
	XMapWindow(dpy, down_Win);
	XMapWindow(dpy, right_Win);
	XMapWindow(dpy, nobbx_Win);
	XMapWindow(dpy, nogrid_Win);
	XMapWindow(dpy, incre_Win);
	XMapWindow(dpy, decre_Win);

	XMapWindow(dpy, save_Win);
	XMapWindow(dpy, exit_Win);
	XMapWindow(dpy, undo_Win);
	XMapWindow(dpy, doit_Win);

	return;
}

void
do_events(void)
{
	XEvent  pe;
	XExposeEvent *ee = (XExposeEvent *) & pe;
	/* XConfigureEvent *ce = (XConfigureEvent *) & pe; hunsoo */
	XButtonPressedEvent *be = (XButtonPressedEvent *) & pe;
	XMotionEvent *me = (XMotionEvent *) & pe;
	int     last_row, last_col;
	int     this_row, this_col;

	while (1) {
		XNextEvent(dpy, &pe); /* this should get first exposure event */
		if (message_exists) {
			XClearWindow(dpy, message_Win);
			message_exists = 0;
		}
		switch (pe.type) {
		case Expose:
			if (ee->window == edit_Win)
				redraw_editWindow();
			else if (ee->window == prev_Win)
				redraw_prevWindow();
			else if (ee->window == pprev_Win)
				redraw_pprevWindow();
			else if (ee->window == ppprev_Win)
				redraw_ppprevWindow();
			else if (ee->window == next_Win)
				redraw_nextWindow();
			else if (ee->window == nnext_Win)
				redraw_nnextWindow();
			else if (ee->window == nnnext_Win)
				redraw_nnnextWindow();

			else if (ee->window == left_Win)
				redraw_leftWindow();
			else if (ee->window == up_Win)
				redraw_upWindow();
			else if (ee->window == down_Win)
				redraw_downWindow();
			else if (ee->window == right_Win)
				redraw_rightWindow();
			else if (ee->window == nobbx_Win)
				redraw_nobbxWindow();
			else if (ee->window == nogrid_Win)
				redraw_nogridWindow();
			else if (ee->window == incre_Win)
				redraw_increWindow();
			else if (ee->window == decre_Win)
				redraw_decreWindow();

			else if (ee->window == info_Win)
				redraw_infoWindow();
			else if (ee->window == charinfo_Win)
				redraw_charinfoWindow();
			else if (ee->window == exit_Win)
				redraw_quitWindow();
			else if (ee->window == save_Win)
				redraw_saveWindow();
			else if (ee->window == undo_Win)
				redraw_undoWindow();
			else if (ee->window == doit_Win)
				redraw_doitWindow();
			else if (ee->window == image_Win)
				redraw_imageWindow();
			else if (ee->window == message_Win)
				put_msg(NULL);
			else if (ee->window == matrix_Win)
				redraw_matrixWindow();
			else if (ee->window == buffers_Win)
				redraw_buffersWindow();
			else if (ee->window == mprev_Win)
				redraw_mprevWindow();
			else if (ee->window == mnext_Win)
				redraw_mnextWindow();
			else if (ee->window == redraw_Win)
				redraw_redrawWindow();
			else if (ee->window == msync_Win)
				redraw_msyncWindow();
			break;

		case ButtonPress:
			if (be->window == edit_Win) {
				if (which_square(be->x, be->y,
				    &last_row, &last_col) == -1)
					break;
				switch (be->button) {
				case Button1:	/* prev button */
					bit_operation(SETBIT,
						last_row, last_col);
					break;
				case Button2:	/* middle button */
					bit_operation(COMBIT,
						last_row, last_col);
					break;
				case Button3:	/* right button */
					bit_operation(CLEARBIT,
						last_row, last_col);
					break;
				}
			} else if (be->window == image_Win)
				alternate_char(be->x);
			else if (be->window == matrix_Win)
				select_char(be->x, be->y, be->button);
			else if (be->window == buffers_Win)
				buffers_handle(be->x, be->y, be->button);
			else if (be->window == prev_Win)
				prevnext_character(-1);
			else if (be->window == pprev_Win)
				prevnext_character(-10);
			else if (be->window == ppprev_Win)
				prevnext_character(-100);
			else if (be->window == next_Win)
				prevnext_character(+1);
			else if (be->window == nnext_Win)
				prevnext_character(+10);
			else if (be->window == nnnext_Win)
				prevnext_character(+100);
			else if (be->window == mprev_Win)
				change_map(-1);
			else if (be->window == mnext_Win)
				change_map(+1);
			else if (be->window == msync_Win)
				find_map();
			else if (be->window == redraw_Win)
				redraw_matrixWindow();
			else if (be->window == undo_Win)
				undo_character();
			else if (be->window == doit_Win)
				doit_character();
			else if (be->window == left_Win)
				shift_character(SHIFT_LEFT);
			else if (be->window == up_Win)
				shift_character(SHIFT_UP);
			else if (be->window == down_Win)
				shift_character(SHIFT_DOWN);
			else if (be->window == right_Win)
				shift_character(SHIFT_RIGHT);
			else if (be->window == nobbx_Win)
				toggle_nobbox();
			else if (be->window == nogrid_Win)
				toggle_nogrid();
			else if (be->window == incre_Win)
				incre_decre(0);
			else if (be->window == decre_Win)
				incre_decre(1);
			else if (be->window == save_Win) {
				char    cmdbuff[132];
				if (firstSave) {
					firstSave = 0;
					sprintf(cmdbuff, "cp %s %s~",
						fontfilename, fontfilename);
					put_msg(cmdbuff);
					system(cmdbuff);
				}
				sprintf(cmdbuff, "copied at %s", fontfilename);
				put_msg(cmdbuff);
				output(fset, fontfilename);
			} else if (be->window == exit_Win)
				return;
			break;

		case MotionNotify:
			if (me->window != edit_Win)
				break;
			if (which_square(me->x, me->y, &this_row, &this_col))
				break;
			if ((this_row != last_row) || (this_col != last_col)) {
				switch (me->state) {
				case Button1Mask:	/* prev button down */
					bit_operation(SETBIT,
						this_row, this_col);
					break;
				case Button2Mask:	/* middle button down */
					bit_operation(COMBIT,
						this_row, this_col);
					break;
				case Button3Mask:	/* right button down */
					bit_operation(CLEARBIT,
						this_row, this_col);
					break;
				}
				last_row = this_row;
				last_col = this_col;
			}
			break;

		default:
			break;
		}
	}
}

/*
 * !! This bounding check makes xfed useful only for fine editing of fonts,
 * since you just cannot extend the font bbox on two sides. We should fix
 * bit_operation to move things around so it can be made to grow in the negative
 * direction as well, and update the bbox appropriately
 */
/*
 * convert mouse x/y to row/col and check for pixel in bounding box return -1
 * if illegal.
 */

int
which_square(int x, int y, int *row, int *col)
{
	*row =  y / square_sideunit;
	*col =  x / square_sideunit;

	return 0;
}
/*
 * set/clear/complement a pixel in current character - row/col must be
 * checked elsewhere
 */
int     mask[32] = {
	0x80000000, 0x40000000, 0x20000000, 0x10000000,
	0x08000000, 0x04000000, 0x02000000, 0x01000000,
	0x00800000, 0x00400000, 0x00200000, 0x00100000,
	0x00080000, 0x00040000, 0x00020000, 0x00010000,
	0x00008000, 0x00004000, 0x00002000, 0x00001000,
	0x00000800, 0x00000400, 0x00000200, 0x00000100,
	0x00000080, 0x00000040, 0x00000020, 0x00000010,
	0x00000008, 0x00000004, 0x00000002, 0x00000001};

void
bit_operation(int what, int row, int col)
{
	int     *bits;
	int	fromthis;

	if (col < 0 || row < 0)
		return;
	if (col >= 32 || row >= fset->f_boundingbox.bb_height)
		return;

	backup_character(tchar, cp);

	bits = &cp->c_rows[row];
	bbp = &cp->c_bbox;

	switch (what) {
		case SETBIT:   *bits |=  mask[col]; break;
		case CLEARBIT: *bits &= ~mask[col]; break;
		case COMBIT:   *bits ^=  mask[col]; break;
	}

	if (cp->c_charname) {
		if (*bits & mask[col]) {
			set_square(row, col);
			XFillRectangle(dpy, image_Win, gc,
				       col + image_x0, row + SPACE, 1, 1);
		} else {
			clear_square(row, col);
			XClearArea(dpy, image_Win, col + image_x0, row + SPACE,
				1, 1, 0);
		}
	} else { /* buffer char case */
		fromthis = (max_width+1) * curr_bindex + 1;
		if (*bits & mask[col]) {
			set_square(row, col);
			XFillRectangle(dpy, buffers_Win, gc,
				col + fromthis, row + SPACE, 1, 1);
		} else {
			clear_square(row, col);
			XClearArea(dpy, buffers_Win,
				col + fromthis, row + SPACE,
				1, 1, 0);
		}
	}

	bbox_check(cp);
	redraw_editWindow();
	/*draw_boundingbox(); */

	cp->c_modified = 1;
	return;
}

void
set_square(int row, int col)
{
	int	x, y;

	x = col * square_sideunit;
	y = row * square_sideunit,

	XFillRectangle(dpy, edit_Win, gc, x, y, pixel_size, pixel_size);

	return;
}

void
clear_square(int row, int col)
{
	int	x, y;
	x = col * square_sideunit;
	y = row * square_sideunit,

	XClearArea(dpy, edit_Win, x, y, pixel_size, pixel_size, 0);
	return;
}

void
draw_boundingbox(void)
{
	int     x1, y1;

	if (dont_drawbbox)
		return;

	x1 = cp->c_bbox.bb_offx - minx;
	y1 = fbbp->bb_height + fbbp->bb_offy
		- cp->c_bbox.bb_offy - cp->c_bbox.bb_height;

	XSetForeground(dpy, gc, red_pixel);
	set_gclinewidth(gc, 2);
	XDrawRectangle(dpy, edit_Win, gc, x1 * square_sideunit,
		y1 * square_sideunit,
		cp->c_bbox.bb_width * square_sideunit - 1,
		cp->c_bbox.bb_height * square_sideunit - 1);
	set_gclinewidth(gc, 1);
	XSetForeground(dpy, gc, foreground_pixel);
	return;
}

void
alternate_char(int x)
{
	int     delta, index;

	if (cp->c_modified) {
		put_msg(undo_or_doit);
		return;
	}

	delta = x / fset->f_boundingbox.bb_width - image_nc;
	index = charIndex + delta;
	if (index < 0)
		index = 0;
	if (index >= fset->f_nchars)
		index = fset->f_nchars - 1;
	if ((delta = index - charIndex) == 0)
		return;

	charIndex += delta;
	cp += delta;
	redraw_editWindow();
	redraw_charinfoWindow();
	redraw_imageWindow();
	return;
}

void
or_operation(struct character *dst, struct character *src)
{
	int	i;

	for (i=0; i < max_height;i++)
		dst->c_rows[i] |= src->c_rows[i];
	dst->c_modified = 1;
	bbox_check(dst);
	return;
}


void
backup_character(struct character *dst, struct character *src)
{
	if (src->c_modified)
		return;
	copy_character(dst, src);
	return;
}

void
copy_character(struct character *dst, struct character *src)
{
	int	i;

	dst->c_bbox = src->c_bbox;
	for (i=0; i < max_height;i++)
		dst->c_rows[i] = src->c_rows[i];

	return;
}

void
doit_character(void)
{
	static char *msg ="char is not modified,\n so there is nothing to do";

	if (cp->c_modified == 0)
		put_msg(msg);
	cp->c_modified = 0;
	if (cp->c_charname == NULL) { /* end of buffer handling */
		redraw_buffersWindow();
		cp = fset->f_characters[charIndex];
		redraw_editWindow();
		redraw_charinfoWindow();
		redraw_imageWindow();
		put_msg("buffer changed\nNow edit current char");
	}

	return;
}

void
undo_character(void)
{
	static char *msg="char is not modified,\n so there is nothing to undo";

	if (cp->c_modified == 0) {
		put_msg(msg);
		return;
	}
	copy_character(cp, tchar);

	cp->c_modified = 0;
	if (cp->c_charname == NULL) { /* end of buffer handling */
		redraw_buffersWindow();
		cp = fset->f_characters[charIndex];
		put_msg("buffer unchanged\nNow edit current char");
	}
	redraw_charinfoWindow();
	redraw_imageWindow();
	redraw_editWindow();
	return;
}

void
prevnext_character(int incre)
{
	int	i;

	if (cp->c_modified) {
		put_msg(undo_or_doit);
		return;
	}

	if (incre > 0) { /* increse */
		for (i = 0; i < incre; i++) {
			if ((charIndex + 1) == fset->f_nchars)
				break;
			charIndex++;
			cp = fset->f_characters[charIndex];
			redraw_editWindow();
			redraw_charinfoWindow();
			redraw_imageWindow();
		}
		if (i != incre)
			put_msg("Last character reached");
		return;
	}
	if (incre < 0) {
		incre *= -1;
		for (i = 0; i < incre; i++) {
			if (charIndex < 1)
				break;
			charIndex--;
			cp = fset->f_characters[charIndex];
			redraw_editWindow();
			redraw_charinfoWindow();
			redraw_imageWindow();
		}
		if (i != incre)
			put_msg("First character reached");
	}
	return;
}



void
shift_character(const int shtype)
{
	int	i;
	int	bound;

	backup_character(tchar, cp);
	bound = fbbp->bb_height;
	switch (shtype) {
		case SHIFT_UP:
			for (i=0; i < (bound-1); i++)
				cp->c_rows[i] = cp->c_rows[i+1];
			cp->c_rows[i] = 0;
			break;
		case SHIFT_DOWN:
			for (i=(bound-2); i >= 0; i--)
				cp->c_rows[i+1] = cp->c_rows[i];
			cp->c_rows[0] = 0;
			break;
		case SHIFT_LEFT:
			for (i=0; i < bound; i++)
				cp->c_rows[i] <<= 1;
			break;
		case SHIFT_RIGHT:
			for (i=0; i < bound; i++)
				cp->c_rows[i] >>= 1;
			break;
	}

	bbox_check(cp);
	cp->c_modified = 1;
	redraw_editWindow();

	if (cp->c_charname)
		redraw_imageWindow();
	else
		redraw_buffersWindow();
	return;
}


void
toggle_nobbox(void)
{
	static char *states[2]={"bounding box will be drawn",
		"bounding box will not be drawn"};

	dont_drawbbox = (0 == dont_drawbbox);
	put_msg(states[dont_drawbbox]);
	redraw_editWindow();
	return;
}

void
toggle_nogrid(void)
{
	static char *states[2]={"grid will be drawn",
		"grid will not be drawn"};

	dont_drawgrid = (0 == dont_drawgrid);

	grid = (dont_drawgrid) ? 0 : 1;
	square_sideunit = (pixel_size + grid);
	put_msg(states[dont_drawgrid]);
	redraw_editWindow();
	return;
}

void
incre_decre(int decrease)
{
	static char *states[2]={"pixel size will increase",
		"pixel size will decrease"};

	if (decrease)
		pixel_size--;
	else
		pixel_size++;

	put_msg(states[decrease]);
	if (pixel_size < 1) {
		pixel_size = 1;
		put_msg("pixel size can not be smaller than 1");
	} else if (pixel_size > 16) {
		pixel_size = 16;
		put_msg("pixel size can not be larger than 16");
	}

	square_sideunit = (pixel_size + grid);
	redraw_editWindow();
	return;
}


void
change_map(int incre)
{
	int	changed;
	static char *msgs[] = {"There is no previous map",
		 "There is no next map"};

	changed = currmap + incre;
	if (changed < 0 || changed >= totalmap) {
		changed = (incre > 0) ? 1 : 0;
		put_msg(msgs[changed]);
		return; 
	}
	currmap = changed;
	redraw_matrixWindow();
	return;
}

void
find_map(void)
{
	currmap = charIndex / 256;
	redraw_matrixWindow();
	return;
}

void
drawbox_inMatrix(void)
{
	int	startno, endno, tmp;
	static int x=0, y=0;

	if (cp->c_charname == NULL)
		return;
	startno = 256 * currmap;
	endno = startno + 256;

	XSetForeground(dpy, gc, blue_pixel);
	XDrawRectangle(dpy, matrix_Win, gc, x, y,
		max_width + 1, max_height + 1);

	if (charIndex < startno || charIndex >= endno) {
		XSetForeground(dpy, gc, foreground_pixel);
		return;
	}

	tmp = charIndex % 256;
	x = (tmp % 16) * (max_width+1);
	y = (tmp / 16) * (max_height+1);

	XSetForeground(dpy, gc, red_pixel);
	XDrawRectangle(dpy, matrix_Win, gc, x, y,
		max_width + 1, max_height + 1);

	XSetForeground(dpy, gc, foreground_pixel);
	return;
}

void
buffers_handle(int x, int y, int whichb)
{
	int	i, thisone;
	static char msgs[256];
	static char *msg0="Thare are still empty buffers, so your\n"
		"clean request was overruled";

	thisone = x / (max_width+1);
	if (thisone < 0 || thisone >= 16) {
		put_msg("character selection failed!");
		return;
	}
	if (buffers_flags[thisone] == 0) {
		put_msg("You selected useless buffer");
		return;
	}

	switch (whichb) {
		case Button1:
			if (cp->c_modified) {
				put_msg(undo_or_doit);
				return;
			}

			cp = buffers[thisone];
			backup_character(tchar, cp);
			redraw_editWindow();
			/* redraw_charinfoWindow(); */
			sprintf(msgs, "Now edit the %dth buffer", thisone);
			put_msg(msgs);
			return;
		case Button2:
			backup_character(tchar, cp);
			or_operation(cp, buffers[thisone]);
			sprintf(msgs, "Or operation with the %dth buffer",
				thisone);
			put_msg(msgs);
			redraw_editWindow();
			if (cp->c_charname)
				redraw_imageWindow();
			else
				redraw_buffersWindow();
			
			break;
		case Button3:
			for (i=0; i < 16 && buffers_flags[i]; i++)
				/* void */ ;

			if (i == 16) { /* all buffs are used.. so clean this */
				buffers_flags[thisone] = 0;
				redraw_buffersWindow();
				sprintf(msgs, "Clean the %dth buffer", thisone);
				put_msg(msgs);
			} else {
				put_msg(msg0);
				break;
			}
	}
	return;
}

void
select_char(int x, int y, int whichb)
{
	int	tmp, thisone;
	static char msgs[256];

	thisone = 256 * currmap + 16 * (y / (max_height+1))
		+ (x / (max_width+1));

	if (thisone < 0 || thisone >= fset->f_nchars) {
		put_msg("character selection failed!");
		return;
	}

	switch (whichb) {
		case Button1:
			if (cp->c_modified) {
				put_msg(undo_or_doit);
				return;
			}

			charIndex = thisone;
			cp = fset->f_characters[thisone];
			redraw_editWindow();
			redraw_charinfoWindow();
			redraw_imageWindow();
			drawbox_inMatrix();
			put_msg("new char was selected");
			return;
		case Button2:
			backup_character(tchar, cp);
			or_operation(cp, fset->f_characters[thisone]);
			redraw_editWindow();
			if (cp->c_charname)
				redraw_imageWindow();
			else
				redraw_buffersWindow();
			put_msg("Or operation");
			return;
		case Button3:
			tmp = find_buffindex();
			copy_character(buffers[tmp],
				fset->f_characters[thisone]);
			redraw_buffersWindow();
			sprintf(msgs, "copied at the %dth buffer", tmp);
			put_msg(msgs);
	}
	return;
}

void
redraw_buffersWindow(void)
{
	int     row, col, colunit, bound, height;
	int	i, x;
	unsigned int     bits;
	struct character *chp;

	XClearWindow(dpy, buffers_Win);
	XSetForeground(dpy, gc, blue_pixel);

	colunit = (max_width+1);

	for (col = 1; col < 16; col++) /* vertical lines */
		XDrawLine(dpy, buffers_Win, gc,
			  col * colunit, 0, col * colunit, buffers_height);

	XSetForeground(dpy, gc, foreground_pixel);

	height = max_height;
	for (i=0; i<16; i++) {
		x = colunit * i + 1;
		chp = buffers[i];
		bbp    = &chp->c_bbox;
		bound = -fbbp->bb_offx + bbp->bb_offx + bbp->bb_width;

		if (buffers_flags[i] == 0)
			continue;
		for (row = 0; row < height; row++) {
			bits = chp->c_rows[row];
			for (col = 0; col < bound; col++) {
				if ((bits & mask[col]))
					XDrawPoint(dpy, buffers_Win, gc,
						x + col, row + SPACE);
			}
		}
	}

	return;
}


void
redraw_matrixWindow(void)
{
	int     row, col, rowunit, colunit, bound;
	int	startno, indx0, indx;
	int	i, j, x, y;
	unsigned int     bits;
	struct character **cpp, *chp;


	XClearWindow(dpy, matrix_Win);
	XSetForeground(dpy, gc, blue_pixel);

	rowunit = (max_height+1);
	colunit = (max_width+1);

	for (row = 1; row < 17; row++) /* horizontal lines */
		XDrawLine(dpy, matrix_Win, gc,
			  0, row * rowunit, matrix_width, row * rowunit);

	for (col = 1; col < 16; col++) /* vertical lines */
		XDrawLine(dpy, matrix_Win, gc,
			  col * colunit, 0, col * colunit, matrix_height);

	XSetForeground(dpy, gc, foreground_pixel);

	startno = 256 * currmap;
	cpp = fset->f_characters;

	for (i=0; i<16; i++) {
		y = rowunit * i + 1;
		indx0 = startno + 16 * i;
		for (j=0; j<16; j++) {
			x = colunit * j + 1;
			indx = indx0 + j; /* character index */

			if (indx < 0 || indx >= fset->f_nchars)
				continue;
			chp = cpp[indx];
			bbp    = &chp->c_bbox;
			bound = -fbbp->bb_offx + bbp->bb_offx + bbp->bb_width;

			for (row = 0; row < fbbp->bb_height; row++) {
				bits = chp->c_rows[row];
				for (col = 0; col < bound; col++) {
					if ((bits & mask[col]))
						XDrawPoint(dpy, matrix_Win, gc,
							x + col, y + row);
				}
			}
		}
	}
	drawbox_inMatrix();

	return;
}

void
redraw_editWindow(void)
{
	int     row, col;
	int     bits;
	int	bound, spanx, spany;

	XClearWindow(dpy, edit_Win);

	spanx = square_sideunit * max_width;
	spany = square_sideunit * max_height;
	if (dont_drawgrid == 0) {
		XSetForeground(dpy, gc, borderPixel);
		bound = maxy - miny;
		for (row = 1; row < bound; row++) {
			XDrawLine(dpy, edit_Win, gc,
				  0, row * square_sideunit - 1,
				  spanx, row * square_sideunit - 1);
		}

		bound = maxx - minx;
		for (col = 1; col < bound; col++) {
			XDrawLine(dpy, edit_Win, gc,
				  col * square_sideunit - 1, 0,
				  col * square_sideunit - 1, spany);
		}

		/*
		 * Two lines through the origin
		 */
		set_gclinewidth(gc, 2);
		XSetForeground(dpy, gc, blue_pixel);

		bound = (max_height + miny) * square_sideunit;
		XDrawLine(dpy, edit_Win, gc, 0, bound,
			spanx, bound);

		bound =  -(minx) * square_sideunit;
		XDrawLine(dpy, edit_Win, gc, bound, 0,
			bound, spany);

		bound =  (-minx + cp->c_dwidth[0]) * square_sideunit;
		XDrawLine(dpy, edit_Win, gc, bound, 0,
			bound, spany);

	}

	set_gclinewidth(gc, 1);
	XSetForeground(dpy, gc, foreground_pixel);

	XDrawLine(dpy, edit_Win, gc,
		0, max_height * square_sideunit - 1,
		spanx, max_height * square_sideunit - 1);
	XDrawLine(dpy, edit_Win, gc,
		max_width * square_sideunit - 1, 0,
		max_width * square_sideunit - 1, spany);

	bound = -minx + cp->c_bbox.bb_offx + cp->c_bbox.bb_width;
	for (row = 0; row < max_height; row++) {
		bits = cp->c_rows[row];
		for (col = 0; col < bound; col++) {
			if (bits & mask[col])
				set_square(row, col);
		}
	}
	drawbox_inMatrix();
	draw_boundingbox();
	return;
}

void
redraw_imageWindow(void)
{
	int     row, col, bound;
	int     x, cIndex, atthis, atthat;
	unsigned int     bits;
	struct character *chp;

	XClearWindow(dpy, image_Win);
	chp = cp - image_nc;
	cIndex = charIndex - image_nc;

	for (x = image_x0 - image_nc * fset->f_boundingbox.bb_width;
	     x < (winW - SPACE) && cIndex < fset->f_nchars;
	     x += fset->f_boundingbox.bb_width, chp++, cIndex++) {
		if (cIndex < 0)
			continue;
		if (cp == chp) {
			atthis = x;
			atthat = atthis + fset->f_boundingbox.bb_width;
		}
		bound = -minx + chp->c_bbox.bb_offx + chp->c_bbox.bb_width;
		for (row = 0; row < fbbp->bb_height; row++) {
			bits = chp->c_rows[row];
			bbp = &chp->c_bbox;
			for (col = 0; col < bound; col++) {
				if ((bits & mask[col]))
					/* && col < bbp->bb_width) */
					XDrawPoint(dpy, image_Win, gc,
						x + col, row + SPACE);
			}
		}
	}
	XDrawLine(dpy, image_Win, gc, atthis, 0, atthis, image_height);
	XDrawLine(dpy, image_Win, gc, atthat, 0, atthat, image_height);
	return;
}

void
redraw_ppprevWindow(void)
{
	redraw_buttonInWindow(ppprev_Button, ppprev_Win,
		ppprev_width, ppprev_height);
	return;
}
void
redraw_pprevWindow(void)
{
	redraw_buttonInWindow(pprev_Button, pprev_Win,
		pprev_width, pprev_height);
	return;
}

void
redraw_prevWindow(void)
{
	redraw_buttonInWindow(prev_Button, prev_Win,
		prev_width, prev_height);
	return;
}
void
redraw_nextWindow(void)
{
	redraw_buttonInWindow(next_Button, next_Win,
		next_width, next_height);
	return;
}

void
redraw_nnextWindow(void)
{
	redraw_buttonInWindow(nnext_Button, nnext_Win,
		nnext_width, nnext_height);
	return;
}

void
redraw_nnnextWindow(void)
{
	redraw_buttonInWindow(nnnext_Button, nnnext_Win,
		nnnext_width, nnnext_height);
	return;
}
void
redraw_redrawWindow(void)
{
	redraw_buttonInWindow(redraw_Button, redraw_Win,
		redraw_width, redraw_height);
	return;
}

void
redraw_msyncWindow(void)
{
	redraw_buttonInWindow(msync_Button, msync_Win,
		msync_width, msync_height);
	return;
}

void
redraw_mnextWindow(void)
{
	redraw_buttonInWindow(mnext_Button, mnext_Win,
		mnext_width, mnext_height);
	return;
}

void
redraw_mprevWindow(void)
{
	redraw_buttonInWindow(mprev_Button, mprev_Win,
		mprev_width, mprev_height);
	return;
}

void
redraw_leftWindow(void)
{
	redraw_buttonInWindow(left_Button, left_Win,
		left_width, left_height);
	return;
}
void
redraw_upWindow(void)
{
	redraw_buttonInWindow(up_Button, up_Win,
		up_width, up_height);
	return;
}
void
redraw_downWindow(void)
{
	redraw_buttonInWindow(down_Button, down_Win,
		down_width, down_height);
	return;
}
void
redraw_rightWindow(void)
{
	redraw_buttonInWindow(right_Button, right_Win,
		right_width, right_height);
	return;
}
void
redraw_nobbxWindow(void)
{
	redraw_buttonInWindow(nobbx_Button, nobbx_Win,
		nobbx_width, nobbx_height);
	return;
}

void
redraw_nogridWindow(void)
{
	redraw_buttonInWindow(nogrid_Button, nogrid_Win,
		nogrid_width, nogrid_height);
	return;
}
void
redraw_increWindow(void)
{
	redraw_buttonInWindow(incre_Button, incre_Win,
		incre_width, incre_height);
	return;
}

void
redraw_decreWindow(void)
{
	redraw_buttonInWindow(decre_Button, decre_Win,
		decre_width, decre_height);
	return;
}

void
redraw_doitWindow(void)
{
	redraw_buttonInWindow(doit_Button, doit_Win,
		doit_width, doit_height);
	return;
}

void
redraw_undoWindow(void)
{
	redraw_buttonInWindow(undo_Button, undo_Win,
		undo_width, undo_height);
	return;
}

void
redraw_saveWindow(void)
{
	redraw_buttonInWindow(save_Button, save_Win,
		save_width, save_height);
	return;
}

void
redraw_quitWindow(void)
{
	redraw_buttonInWindow(exit_Button, exit_Win,
		exit_width, exit_height);
	return;
}

void
redraw_buttonInWindow(Pixmap pixmap, Window win, int w, int h)
{
	XClearWindow(dpy, win);
	XCopyPlane(dpy, pixmap, win, gc, 0, 0, w, h, 0, 0, 1);
	return;
}

void
redraw_infoWindow(void)
{
	char    buffer[200];
	sprintf(buffer, "File: %s Name: '%s' %d characters",
		fontfilename, fset->f_fontname, fset->f_nchars);
	XDrawImageString(dpy, info_Win, gc, 5, 13, buffer, strlen(buffer));
	return;

}
void
redraw_charinfoWindow(void)
{
	char buffer[200];

	XClearWindow(dpy, charinfo_Win);
	sprintf(buffer, "[%3d%%] %3dth 0x%4x(%d) : \"%s\"",
		(100 * cp->c_order)/fset->f_nchars, cp->c_order,
		cp->c_encoding, cp->c_encoding, cp->c_charname);
	XDrawImageString(dpy, charinfo_Win, gc, 5, 13, buffer, strlen(buffer));
	return;
}

void
put_msg(char *line)
{
	static char buffer[256];
	char	*charpp[32], **cpp, *p;
	int	y;

	XClearWindow(dpy, message_Win);
	if (line == NULL || line[0] == '0')
		return;

	strcpy(buffer, line);
	message_exists = 1;
	cpp = charpp;
	for (p = buffer, *cpp = buffer; *p; p++)
		if (*p == '\n') {
			*p = 0;
			*++cpp = (p+1);
		}
	*++cpp = NULL;

	for (cpp = charpp, y=10; *cpp; cpp++, y += 13)
		XDrawImageString(dpy, message_Win, gc,
			5, y, *cpp, strlen(*cpp));
	return;
}

unsigned long
NameToPixel(char *name)
{
	XColor  ecolor;

	if (!name || !*name)
		err("%s(): you gave NULL color name ", __F);
	if (!XParseColor(dpy, DefaultColormap(dpy, screen), name, &ecolor))
		err("%s(): unknown color \"%s\"\n", __F, name);

	if (!XAllocColor(dpy, DefaultColormap(dpy, screen), &ecolor))
		err("%s:  unable to allocate color for \"%s\"\n", __F, name);

	return ecolor.pixel;
}

void
set_gclinewidth(GC gc, const int linewidth)
{
	unsigned long mask = GCLineWidth;
	XGCValues	xgcv;

	if (linewidth < 0)
		return;
	xgcv.line_width = linewidth;
	XChangeGC(dpy, gc, mask, &xgcv);
	return;
}

void
make_buffers(void)
{
	struct character *chp;
	int	i, size;

	buffers = (struct character **) malloc(sizeof(struct character *) * 16);
	if (buffers == NULL)
		err("%s(): malloc failed : buffers == NULL", __F);

	size = sizeof(struct character) * 16;
	chp = (struct character *) malloc(size);
	if (chp == NULL)
		err("%s(): malloc failed : chp == NULL", __F);
	memset(chp, 0x00, size);

	for (i=0; i<16; i++, chp++) {
		buffers[i] = chp;
		size = sizeof(int) * max_height;
		chp->c_rows = (int *) malloc(size);
		if (chp->c_rows == NULL)
			err("%s(): malloc failed : chp->c_rows == NULL", __F);
		memset(chp->c_rows, 0x00, size);
		buffers_flags[i] = 0;
	}
	return;
}

int
find_buffindex(void)
{
	int	i;
	static int buffers_index;

	buffers_index %= 16;
	for (i=0; i < 16; i++)
		if (buffers_flags[i] == 0)
			break;
	if (i < 16) {
		buffers_flags[i] = 1;
		curr_bindex = i;
		return i;
	}
	curr_bindex = buffers_index++;
	return curr_bindex;
}
